; WARNING: DO NOT TRY TO RUN THIS PROGRAM ON THE TI83!!! IT IS TI83 PLUS ONLY!!!

	.nolist
	#include "ti83plus.inc"
	.list
#ifdef TI83P
	.org	progstart-2
	.db	$BB,$6D
#else
	.org	progstart
#endif

numoflevs	=sram
curlevel	=sram+1
numoflines	=sram+2
linedata	=sram+3	;sram+4, sram+5, sram+6
xcoord		=sram+7
ycoord		=sram+8
x2coord		=sram+9
y2coord		=sram+10
startx		=sram+11
starty		=sram+12
curline		=sram+13
pointer		=sram+14

#define	curFat		curFat_lbl+1
#define filestart	filestart_lbl+1
#define firstlevel	firstlevel_lbl+1
#define direction	direction_lbl+1
#define flashvar	flashvar_lbl+1
#define flashvar2	flashvar2_lbl+1

	ret
	jr	nc,start
	.db	"Nibbles Level Editor",0
start:
	bcall(_clrlcdf)
	res 4,(iy+23h)				; Used in the "chkenter" routine nz=enter is being pressed
	res 5,(iy+23h)				; Used in the "moveline" routine nz=line is drawn left<->right
	res plotLoc,(iy+plotFlags)		; Draw to the buffer and the screen with darkline
	ld hl,beginstr
	ld e,1
	call disphlmsgs
nogoodkey:
	call waitkey
	cp 22h
	jp z,newset
	cp 12h
	ret z
	cp 1ah
	jr nz,nogoodkey
chooselevel:
	bcall(_clrlcdf)
	ld hl,choosestr
	ld e,0
	call disphlmsgs
resetlevels:
	ld hl,(vat)
	ld ix,detectstr
	call ionDetect
	ret nz
loadbuffer:
	ld (curFat),de
	ld (filestart),hl
	ld c,-1
	xor a
	cpir
	ld a,(hl)
	ld (numoflevs),a
	inc hl
	inc hl
	inc hl
	ld (firstlevel),hl
filestart_lbl:
	ld hl,0000
	ld de,(64-8)*256+20
	ld (pencol),de
	bcall(_vputs)
	call erasetoend
wrongkey:
	call waitkey
	cp 26
	jr z,wrong
	cp 34
	jr z,right
	jr wrongkey
wrong:
curFat_lbl:
	ld hl,0000
	ld ix,detectstr
	call ionDetect
	jp nz,resetlevels
	jp loadbuffer
right:
	ld a,1
	ld (curlevel),a
mainmenu:
	bcall(_clrlcdf)
	set textinverse,(iy+textflags)
	ld hl,menutitle
	ld de,3*256+0
	ld (currow),de
	bcall(_puts)
	res textinverse,(iy+textflags)
	ld e,1
	ld hl,menustr
	call disphlmsgs
	call findlevel		;hl points to level data now
	xor a
	inc hl
	ld bc,62
	cpir
	dec hl
	ld (pointer),hl
	ld a,63
	sbc a,c
	srl a
	dec a
	srl a
	ld (numoflines),a
mainmenuloop:
	call waitkey
	cp 34
	jp z,newline
	cp 26
	jp z,delline
	cp 18
	jp z,startloc
	cp 35
	jp z,viewlevel
	cp 27
	jp z,nextlevel
	cp 19
	jp z,prevlevel
	cp 36
	jp z,start
	jr mainmenuloop
newline:
	ld a,15
	ld hl,numoflines
	cp (hl)
	jp z,mainmenu
	call displevel
	call center
newline_loop1:
	set 3,(iy+23h)
	call movecursor
	call chkcoords
	bit 3,(iy+23h)
	jr z,newline1
	call flashreset
	call ionFastCopy
newline1:
	set plotLoc,(iy+plotFlags)
	call flash
	call c,cursordraw
	res plotLoc,(iy+plotFlags)
	ei
	halt
	halt
	call chkenter
	jr nz,newline_loop1
	ld a,(xcoord)
	ld (x2coord),a
	ld a,(ycoord)
	ld (y2coord),a
newline_loop2:
	set 3,(iy+23h)
	call moveline
	call chkcoords
	bit 3,(iy+23h)
	call nz,flashreset
	call ionFastCopy
	set plotLoc,(iy+plotFlags)
	call flash
	call c,drawlinecoords
	res plotLoc,(iy+plotFlags)
	ei
	halt
	halt
	call chkenter
	jr nz,newline_loop2
	call fixcoords
	ld hl,(pointer)
	ld (hl),b
	inc hl
	ld (hl),c
	inc hl
	ld (hl),d
	inc hl
	ld (hl),e
	jp mainmenu
	
	
delline:
	ld a,0
	ld (curline),a
	call displevel
dellineup:
	ld a,(numoflines)
	or a
	jr z,nothingtodelete
	ld hl,curline
	cp (hl)
	jr z,delline_loop1
	ld hl,(pointer)
	dec hl
	dec hl
	dec hl
	dec hl
	ld (pointer),hl
	ld hl,curline
	inc (hl)
	call flashreset
delline_loop1:
	call ionFastCopy
	set plotLoc,(iy+plotFlags)
	call flash
	call c,flashline
	res plotLoc,(iy+plotFlags)
	call getarrows2
	cp 0f7h
	jr z,dellineup
	cp 0feh
	jr z,dellinedown
	ld b,10
	ei
delline_loop3:
	halt
	djnz delline_loop3
	call chkenter
	jr nz,delline_loop1
	ld hl,(pointer)
	ld a,(curline)
	push hl
	pop de
	inc hl
	inc hl
	inc hl
	inc hl
delline_loop2:
	ld bc,4
	ldir
	dec a
	jr nz,delline_loop2
	xor a
	dec de
	ld (de),a
	dec de
	ld (de),a
	dec de
	ld (de),a
	dec de
	ld (de),a
	jp mainmenu
dellinedown:
	ld a,(curline)
	dec a
	jr z,delline_loop1
	ld hl,(pointer)
	inc hl
	inc hl
	inc hl
	inc hl
	ld (pointer),hl
	ld hl,curline
	dec (hl)
	call flashreset
	jr delline_loop1

nothingtodelete:
	bcall(_clrlcdf)
	ld hl,deletestr
	ld e,3
	call disphlmsgs
	call waitkey
	jp mainmenu
	
	
startloc:
	call displevel
	call center
startloc_loop1:
	set 3,(iy+23h)
	call movecursor
	call chkcoords
	bit 3,(iy+23h)
	call nz,flashreset
	call ionFastCopy
	set plotLoc,(iy+plotFlags)
	call flash
	call c,cursordraw
	res plotLoc,(iy+plotFlags)
	ei
	halt
	halt
	call chkenter
	jr nz,startloc_loop1
	call findlevel
	ld a,(xcoord)
	dec a
	dec a
	ld (hl),a
	inc hl
	ld a,(ycoord)
	ld b,a
	ld a,64
	sub b
	ld (hl),a
	jp mainmenu


viewlevel:
	call displevel
	call waitkey
	jp mainmenu
nextlevel:
	bcall(_clrlcdf)
	ld hl,curlevel
	ld a,(numoflevs)
	cp (hl)
	jp z,dispwhatnow
	inc (hl)
dispwhatnow:
	ld hl,dispwhatnowstr
	ld e,1
	call disphlmsgs
	ld a,(curlevel)
	ld l,a
	ld h,0
	ld de,11*256+3
	ld (currow),de
	push de
	bcall(_disphl)
	pop de
	inc e
	ld (currow),de
	ld a,(numoflevs)
	ld l,a
	ld h,0
	bcall(_disphl)
	call waitkey
	jp mainmenu
prevlevel:
	bcall(_clrlcdf)
	ld a,(curlevel)
	cp 1
	jr z,dispwhatnow
	dec a
	ld (curlevel),a
	jr dispwhatnow

newset:
	bcall(_clrlcdf)
	ld hl,inputnamestr
	ld e,0
	call disphlmsgs
	ld de,5*256+7
	ld (currow),de
	ld hl,op1
	ld a,06h
	ld (hl),a
	ld b,8
newset_loop1:
	ei
	halt
	push de
	push hl
	bcall(_getkey)
	pop hl
	pop de
	cp 05h
	jr z,done
	cp 0ah
	jr z,backspace
	cp 8eh
	jr c,newset_loop1
	cp 0cch
	jr z,theta
	cp 0b4h
	jr nc,newset_loop1
	cp 98h
	jr z,newset_loop1
	cp 99h
	jr z,newset_loop1
	inc b
	dec b
	jr z,newset_loop1
	cp 98h
	jr c,number
letter:
	sub 59h
	jr display
theta:
	ld a,0b9h
number:
	sub 5eh
display:
	bcall(_putc)
	inc d
	ld (currow),de
	inc hl
	ld (hl),a
	dec b
	jr newset_loop1
backspace:
	dec d
	ld (currow),de
	ld a,20h
	bcall(_putc)
	ld (currow),de
	inc b
	dec hl
	jr newset_loop1
done:
	inc hl
	xor a
	ld (hl),a
	bcall(_chkfindsym)
	jp nc,alreadythere
	bcall(_op1toop3)
	ld hl,safespot+20
	ld de,safespot+19
	ld bc,19
	lddr
	push hl
	bcall(_clrlcdf)
	ld hl,inputtitlestr
	ld e,0
	call disphlmsgs
	ld de,(64-8)*256+20
	ld (pencol),de
	pop hl
	dec hl
	ld b,20
	set 3,(iy+24h)	; lowercase
newset_loop2:
	ei
	halt
	push de
	push hl
	bcall(_getkey)
	pop hl
	pop de
	cp 05h
	jr z,done2
	cp 0ah
	jr z,backspace2
	cp 0fch
	jr z,lowercase
	cp 99h
	jr z,space
	cp 9ah
	jr c,newset_loop2
	cp 0b4h
	jr nc,newset_loop2
	inc b
	dec b
	jr z,newset_loop2
	sub 59h
	jr display2
space:
	ld a,20h
	jr display2
lowercase:
	ld a,(8446h)	;second byte of 2 byte keycode
	cp kLa
	jr c,newset_loop2
	cp kLz+1
	jr nc,newset_loop2
	sub 81h
display2:
	ld (hl),a
	inc hl
	push hl
	push de
	ld (pencol),de
	ld hl,safespot
	bcall(_vputs)
	pop de
	pop hl
	dec b
	jr newset_loop2
backspace2:
	dec hl
	ld (hl),0
	push hl
	push de
	push hl
	push de
	ld (pencol),de
	call erasetoend
	pop de
	pop hl
	ld (pencol),de
	ld hl,safespot
	bcall(_vputs)
	pop de
	pop hl
	inc b
	jr newset_loop2
done2:
	res 3,(iy+24h)
	bcall(_clrlcdf)
	ld hl,inputnumberstr
	ld e,0
	call disphlmsgs
	call newset_loop3
	ld l,a
	ld h,0
	ld de,4*256+7
	ld (currow),de
	push hl
	push hl
	push af
	bcall(_pushRealO1)
	pop af
	pop hl
	ld l,a
	ld h,0
	bcall(_disphl)
	bcall(_popRealO1)
	pop hl
	ld h,10
	bcall(_htimesl)
	push hl
	call newset_loop3
	pop hl
	ld e,a
	ld d,0
	add hl,de
	ld a,l
	jr jumphere
newset_loop3:
	bcall(_getkey)
	cp 8eh
	jr c,newset_loop3
	cp 98h
	jr nc,newset_loop3
	sub 8eh
	ret
jumphere:
	push af
	ld hl,safespot
	ld bc,-1
	xor a
	cpir
	ld hl,9
	sbc hl,bc
	pop af
	push af
	ld b,a
	ld de,62
newset_loop4:
	add hl,de
	djnz newset_loop4
#ifdef TI83P
	bcall(_createProtProg)
#endif
	inc de
	inc de
	ld hl,detectstr2
newset_loop5:
	ld a,(hl)
	ld (de),a
	inc de
	inc hl
	or a
	jr nz,newset_loop5
endofstr:
	pop af
	push af
	ld (de),a
	xor a
	inc de
	ld (de),a
	inc de
	ld (de),a
	ex de,hl
	inc hl
	ld de,7*256+8
	pop bc		;b=numoflevs
newset_loop6:
	push bc
	ld bc,59
	ld (hl),d
	inc hl
	ld (hl),e
	inc hl
	ld (hl),a
	push de
	ld d,h
	ld e,l
	inc de
	ldir
	pop de
	inc hl
	pop bc
	djnz newset_loop6
	jp start
alreadythere:
	bcall(_clrlcdf)
	ld hl,alreadytherestr
	ld e,0
	call disphlmsgs
	call waitkey
	jp start



;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	
;----> CALLS

erasetoend:
	ld a,20h
	bcall(_vputmap)
	jr nc,erasetoend
	ret

flashline:
	ld hl,(pointer)
	ld b,(hl)
	inc hl
	ld c,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
unfixcoords:
	ld a,b
	cp d
	jr z,unfix1
	cp d
	jr c,unfix2
	dec b
	jr unfixed
unfix2:
	dec d
	jr unfixed
unfix1:
	ld a,c
	cp e
	jr c,unfix3
	inc e
	jr unfixed
unfix3:
	inc c
unfixed:
	push de
	call fourpixelsoff
	pop de
	ld b,d
	ld c,e
fourpixelsoff:
	ld d,0
	bcall(_ipoint)
	inc b
	bcall(_ipoint)
	dec c
	bcall(_ipoint)
	dec b
	bcall(_ipoint)
	ret


disphlmsgs:
        ld      d,0
show_loop:
        ld      (currow),de
        push    de
        bcall(_puts)
        pop     de
        ld      a,(hl)
        inc     a
        ret     z
        inc     e
        jr      show_loop

waitkey:
	ei
	bcall(_getcsc)
	or a
	jr z,waitkey        
        ret
        
displevel:
	bcall(_clrlcdf)
	bcall(_cleargbuf)
	ld bc,01*256+01
	ld de,01*256+62
	call vertline
	ld bc,93*256+62
	call horizline
	inc c
	ld de,93*256+02
	call vertline
	ld bc,01*256+02
	call horizline
	call findlevel
	ld a,(hl)
	ld (startx),a
	inc hl
	ld a,(hl)
	ld (starty),a
	inc hl
	ld b,15
drawlevel:
	push bc
	ld b,(hl)
	inc hl
	ld c,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld e,(hl)
	inc hl
	push hl
	call drawline
	pop hl
	pop bc
	djnz drawlevel
	ret
	
;----> Double thickness line (it tests for horiz/vert, rets if neither or b=0)
drawline:
	ld a,b
	or a
	ret z
	cp d
	jr z,vertline
	ld a,c
	cp e
	jr z,horizline
	ret
;----> Double thickness horizontal line
horizline:
	bcall(_darkline)
	dec c
	dec e
	bcall(_darkline)
	ret
;----> Double thickness vertical line
vertline:
	bcall(_darkline)
	inc b
	inc d
	bcall(_darkline)
	ret
;----> Double thickness line without proper coords
drawlinecoords:
	call fixcoords
	jr drawline
fixcoords:
	ld hl,xcoord
	ld b,(hl)	;x
	inc hl
	ld c,(hl)	;y
	inc hl
	ld d,(hl)	;x2
	inc hl
	ld e,(hl)	;y2
	ld a,b
	cp d
	jr z,vertline2
	cp d
	jr c,incd
	inc b
	ret
incd:
	inc d
	ret
vertline2:
	ld a,c
	cp e
	jr c,decc
	dec e
	ret
decc:
	dec c
	ret

;----> Routine to find the level
; Inputs: (curlevel), (firstlevel)
; Outputs: hl=pointer to level
; Destroyed: b,de,a
findlevel:
	ld a,(curlevel)
	ld b,a
firstlevel_lbl:
	ld hl,0000
	ld de,62
	dec b
	jr z,_firstlevel
findlevel_loop1:
	add hl,de
	djnz findlevel_loop1
_firstlevel:
	ret
	
center:
	ld a,96/2+1
center1:
	ld (xcoord),a
	ld (x2coord),a
	ld a,64/2
	ld (ycoord),a
	ld (y2coord),a
	ret
center2:
	ld a,96/2
	jr center1
	
;----> Routine to move cursor
; Inputs: (xcoord),(ycoord)
; Outputs: (xcoord),(ycoord) for new location
movecursor:
	call getarrows
	cp 0feh
	jr z,cursorup
	cp 0fdh
	jr z,cursorleft
	cp 0fbh
	jr z,cursorright
	cp 0f7h
	jr z,cursordown
	res 3,(iy+23h)
	ret
cursorup:
	ld hl,ycoord
	dec (hl)
	dec (hl)
	ret
cursordown:
	ld hl,ycoord
	inc (hl)
	inc (hl)
	ret
cursorright:
	ld hl,xcoord
	inc (hl)
	inc (hl)
	ret
cursorleft:
	ld hl,xcoord
	dec (hl)
	dec (hl)
	ret

getarrows:
	ld a,0ffh
	out (1),a
getarrows2:
	ld a,0feh
	out (1),a
	in a,(1)
	ret

;----> Routine to extend a line from a given point either horizontally or vertically
moveline:
	call getarrows
	cp 0feh
	jr z,movelineup
	cp 0fdh
	jr z,movelineleft
	cp 0fbh
	jr z,movelineright
	cp 0f7h
	jr z,movelinedown
	res 3,(iy+23h)
	ret
movelinedown:
	bit 5,(iy+23h)		;z if vert
	call nz,makeequal
	res 5,(iy+23h)
	jr cursordown
movelineup:
	bit 5,(iy+23h)		;z if vert
	call nz,makeequal
	res 5,(iy+23h)
	jr cursorup
movelineleft:
	bit 5,(iy+23h)		;z if vert
	call z,makeequal
	set 5,(iy+23h)
	jr cursorleft
movelineright:
	bit 5,(iy+23h)		;z if vert
	call z,makeequal
	set 5,(iy+23h)
	jr cursorright
	
makeequal:
	ld a,(x2coord)
	ld (xcoord),a
	ld a,(y2coord)
	ld (ycoord),a
	ret

cursordraw:
	ld a,(xcoord)
	ld (x2coord),a
	ld a,(ycoord)
	ld (y2coord),a
	jp drawlinecoords


;----> Routine to tell whether or not to draw a line/pixel (timed)
; Inputs: none
; Outputs: CA=1 if yes, CA=0 if no
; Destroyed: a,hl
flash:
	ld hl,flashvar
	inc (hl)
flashvar_lbl:
	ld a,0
	cp 70
	jr z,flashreset
	cp 35
	ret
flashreset:
	xor a
	ld (flashvar),a
	ret
	
;----> Routine to see if enter has been pressed, not held
; Inputs: bit4,(iy+23h) = 1 if already pressed (set by this routine)
; Outputs: z=1 if it is pressed
; Destroyed: a
chkenter:
	ld a,0ffh
	out (1),a
	ld a,0fdh
	out (1),a
	in a,(1)
	cp 254
	jr nz,enterletgo
	bit 4,(iy+23h)
	ret nz
	set 4,(iy+23h)
	cp 254
	ret
enterletgo:
	res 4,(iy+23h)
	or a
	ret

;----> Routine to see if the coordinates are over the limits, fixes them
; Inputs: (xcoord),(ycoord)
; Outputs: (xcoord),(ycoord)
; Destroyed: a
chkcoords:
	ld a,(xcoord)
	cp 3
	jr c,chkleft
	cp 92
	jr nc,chkright
	ld a,(ycoord)
	cp 3
	jr c,chkup
	cp 61
	jr nc,chkdown
	ret
chkleft:
	inc a
	inc a
	ld (xcoord),a
	ret
chkright:
	dec a
	dec a
	ld (xcoord),a
	ret
chkup:
	inc a
	inc a
	ld (ycoord),a
	ret
chkdown:
	dec a
	dec a
	ld (ycoord),a
	ret
	
;----> STRINGS
beginstr:
	.db " Welcome to the",0
	.db "    Nibbles",0
	.db "  Level Editor",0
	.db 0,"1:New Level Set",0
	.db "2:Load Level Set",0
	.db "3:Quit",0,-1
menutitle:
	.db "Main Menu:",0
menustr:
	.db "1: New Line",0
	.db "2: Delete Line",0
	.db "3: Starting Loc.",0
	.db "4: View Level",0
	.db "5: Next Level",0
	.db "6: Prev. Level",0
	.db "7: Quit",0,-1
detectstr:
	.db "Nib1GL",0
choosestr:
	.db "Choose the level",0
	.db "  set to edit",0,0
	.db "1: Accept",0
	.db "2: Next set",0,-1
dispwhatnowstr:
	.db "Now editing:",0,0
	.db "Level:",0
	.db "Max Levels:",0,-1
deletestr:
	.db "There are no",0
	.db "lines to delete",0,-1
inputnamestr:
	.db "Input the name",0
	.db "of the program",0
	.db "to be created.",0
	.db "max = 8 chars",0
	.db "(A-Z, ",5bh,", 0-9)",0,-1
inputtitlestr:
	.db "Input the title",0
	.db "of the level set",0
	.db "to be created.",0
	.db "max = 20 chars",0
	.db "(A-Z, a-z)",0,-1
detectstr2:
	.db "Nib1GL"
safespot:
	.db 0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0	; 20 chars + terminating zero
alreadytherestr:
	.db "There is already",0
	.db "a program with",0
	.db "that name on",0
	.db "your calculator.",0,-1
inputnumberstr:
	.db "input the #",0
	.db "of levels to be",0
	.db "created.",0
	.db "MUST BE 2 DIGITS"
	.db "   (i.e. 06)",0,-1
.end